/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";
  rJS(window)

  .declareAcquiredMethod("get_model", "get_model")

  .setState({
    storage : null
  })

  .ready(function(){
    var gadget = this;
    return gadget.get_model()
      .push(function(result){
        return gadget.changeState({
          storage : result
        });
    });
  })

  .declareMethod("read_file_new", function(link){
    var  gadget = this,
        xmlhttp = new XMLHttpRequest();

    xmlhttp.onreadystatechange = function() {
      if (xmlhttp.status == 200 && xmlhttp.readyState == 4){
        var rss,
            title;
        rss = xmlhttp.responseText;
        title = rss.slice(rss.indexOf("<title>")+7, rss.indexOf("</title>"));
        return gadget.is_already_parsed(title)
          .push(function(is_parsed){
            if (!is_parsed){
              return gadget.remove_css(rss)
                .push(function(rss_without_css){
                  return gadget.state.storage.add_attachment(title, rss_without_css);
                });
            }
          });
      }
    }
    xmlhttp.open("GET", link, true);
    xmlhttp.send();
  })

  .declareMethod("remove_css", function(body){
    var regEx = new RegExp('(style="(.*?)"|style=&quot(.*?)&quot)', 'gi');
    return body.replace(regEx, "");
  })

  .declareMethod("is_already_parsed", function(title){
    return this.state.storage.all_loaded_docs()
      .push(function (result){
        var i;
        for (i = 0; i<result.data.rows.length; i+=1){
          if (result.data.rows[i].id === title) return true;
        }
        return false;
      });
  });

  /*.declareMethod("read_file", function(link) {
    var gadget,
      xmlhttp,
      cur_text,
      promise_list = [],
      feed_title;
      gadget = this;
    xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function() {
      if (xmlhttp.status == 200 && xmlhttp.readyState == 4) {
        cur_text = xmlhttp.responseText,
        feed_title = cur_text.slice(cur_text.indexOf("<title>")+7, cur_text.indexOf("</title>"));
        return gadget.is_already_parsed(feed_title)
          .push (function (resultat){
            if (!resultat){
              promise_list.push(gadget.state.storage.loaded_doc(feed_title, {"loaded" : "true"}));
              cur_text = cur_text.slice(cur_text.indexOf("<item>"), cur_text.length - 1);
              while (cur_text.indexOf("<item>") > -1) {
                promise_list.push(gadget.parse(cur_text));
                cur_text = cur_text.slice(cur_text.indexOf("</item>") + 6, cur_text.length - 1);
              }
              RSVP.all(promise_list);
            }
          });
      }
    };
    xmlhttp.open("GET", link, true);
    xmlhttp.send();
  })

.declareMethod("parse", function(local_cur_text) {
  var title_start = local_cur_text.indexOf("<title>") + 7,
      title_end = local_cur_text.indexOf("</title>"),
      link_start = local_cur_text.indexOf("<link>") + 6,
      link_end = local_cur_text.indexOf("</link>"),
      body_start = local_cur_text.indexOf("<description>"),
      body_end = local_cur_text.indexOf("</description>") + 14;
  return this.remove_css(local_cur_text.slice(body_start, body_end))
    .push (function(result){
      return gadget.state.storage.put({
        "title": local_cur_text.slice(title_start, title_end),
        "link": local_cur_text.slice(link_start, link_end),
        "body": result
      });
    });
})*/

}(window, RSVP, rJS, jIO));
